diff --git a/django/db/models/sql/query.py b/django/db/models/sql/query.py
index 9a5666b..02af89a 100644
--- a/django/db/models/sql/query.py
+++ b/django/db/models/sql/query.py
@@ -1065,8 +1065,9 @@ class Query(object):
 
         try:
             field, target, opts, join_list, last, extra_filters = self.setup_joins(
-                    parts, opts, alias, True, allow_many, can_reuse=can_reuse,
-                    negate=negate, process_extras=process_extras)
+                    parts, opts, alias, True, allow_many, allow_explicit_fk=True,
+                    can_reuse=can_reuse, negate=negate,
+                    process_extras=process_extras)
         except MultiJoin, e:
             self.split_exclude(filter_expr, LOOKUP_SEP.join(parts[:e.level]),
                     can_reuse)
diff --git a/docs/topics/db/queries.txt b/docs/topics/db/queries.txt
index 3457913..b63ff10 100644
--- a/docs/topics/db/queries.txt
+++ b/docs/topics/db/queries.txt
@@ -365,6 +365,17 @@ translates (roughly) into the following SQL::
 
    .. _`Keyword Arguments`: http://docs.python.org/tutorial/controlflow.html#keyword-arguments
 
+.. versionchanged:: 1.4
+
+The field specified in a lookup has to be the name of a model field.
+There's one exception though, in case of a
+:class:`~django.db.models.fields.ForeignKey` you can specify the field
+name suffixed with ``_id``. In this case, the value parameter is expected
+to contain the raw value of the foreign model's primary key. For
+example::
+
+    >>> Entry.objects.filter(blog_id__exact=4)
+
 If you pass an invalid keyword argument, a lookup function will raise
 ``TypeError``.
 
diff --git a/tests/modeltests/many_to_one/tests.py b/tests/modeltests/many_to_one/tests.py
index 2d474c0..b9ba711 100644
--- a/tests/modeltests/many_to_one/tests.py
+++ b/tests/modeltests/many_to_one/tests.py
@@ -1,6 +1,6 @@
 from datetime import datetime
 from django.test import TestCase
-from django.core.exceptions import FieldError
+from django.core.exceptions import FieldError, MultipleObjectsReturned
 from models import Article, Reporter
 
 class ManyToOneTests(TestCase):
@@ -226,10 +226,6 @@ class ManyToOneTests(TestCase):
                 "<Article: John's second story>",
                 "<Article: This is a test>",
             ])
-        # You need two underscores between "reporter" and "id" -- not one.
-        self.assertRaises(FieldError, Article.objects.filter, reporter_id__exact=self.r.id)
-        # You need to specify a comparison clause
-        self.assertRaises(FieldError, Article.objects.filter, reporter_id=self.r.id)
 
     def test_reverse_selects(self):
         a3 = Article.objects.create(id=None, headline="Third article",
@@ -370,3 +366,33 @@ class ManyToOneTests(TestCase):
         self.r.cached_query = Article.objects.filter(reporter=self.r)
         from copy import deepcopy
         self.assertEqual(repr(deepcopy(self.r)), "<Reporter: John Smith>")
+
+    def test_explicit_fk(self):
+        # Create a new Article with get_or_create using an explicit value
+        # for a ForeignKey.
+        a2, created = Article.objects.get_or_create(id=None,
+                                                    headline="John's second test",
+                                                    pub_date=datetime(2011, 5, 7),
+                                                    reporter_id=self.r.id)
+        self.assertTrue(created)
+        self.assertEqual(a2.reporter.id, self.r.id)
+
+        # You can specify filters containing the explicit FK value.
+        self.assertQuerysetEqual(Article.objects.filter(reporter_id__exact=self.r.id),
+            [
+                "<Article: John's second test>",
+                "<Article: This is a test>",
+            ])
+
+        # Create an Article by Paul for the same date.
+        a3 = Article.objects.create(id=None, headline="Paul's commentary",
+                                    pub_date=datetime(2011, 5, 7),
+                                    reporter_id=self.r2.id)
+        self.assertEqual(a3.reporter.id, self.r2.id)
+
+        # Get should respect explicit foreign keys as well.
+        self.assertRaises(MultipleObjectsReturned,
+                          Article.objects.get, reporter_id=self.r.id)
+        self.assertEqual(repr(Article.objects.get(reporter_id=self.r2.id,
+                                             pub_date=datetime(2011, 5, 7))),
+                         repr(a3))