diff --git a/django/core/management/commands/dumpdata.py b/django/core/management/commands/dumpdata.py
index e55ae7b..7bdcc42 100644
--- a/django/core/management/commands/dumpdata.py
+++ b/django/core/management/commands/dumpdata.py
@@ -13,47 +13,28 @@ class Command(BaseCommand):
     args = '[appname ...]'
 
     def handle(self, *app_labels, **options):
-        from django.db.models import get_app, get_apps, get_models, get_model
+        from django.db.models import get_app, get_apps, get_models
         from django.core import serializers
 
         format = options.get('format', 'json')
         indent = options.get('indent', None)
-        
+
         if len(app_labels) == 0:
             app_list = get_apps()
         else:
-            app_list = {}
-            for app_label in app_labels:
-                app_model_label = app_label.split('.')
-                if len(app_model_label) <= 1:
-                    # This is just an app
-                    app_list[app_model_label[0]] = None
-                else:
-                    # This is app.Model
-                    if app_model_label[0] in app_list.keys() and app_list[app_model_label[0]]:
-                            app_list[app_model_label[0]].append(app_model_label[1])
-                    else:
-                        app_list[app_model_label[0]] = [app_model_label[1]]
+            app_list = [get_app(app_label) for app_label in app_labels]
 
         # Check that the serialization format exists; this is a shortcut to
         # avoid collating all the objects and _then_ failing.
-        
         try:
             serializers.get_serializer(format)
         except KeyError:
             raise CommandError("Unknown serialization format: %s" % format)
 
         objects = []
-        for app_label in app_list:
-            if app_list[app_label]:
-                for model_label in app_list[app_label]:
-                    model = get_model(app_label, model_label)
-                    objects.extend(model.objects.all())
-            else:
-                app = get_app(app_label)
-                for model in get_models(app):
-                    objects.extend(model.objects.all())
-
+        for app in app_list:
+            for model in get_models(app):
+                objects.extend(model.objects.all())
         try:
             return serializers.serialize(format, objects, indent=indent)
         except Exception, e:
diff --git a/tests/modeltests/fixtures/models.py b/tests/modeltests/fixtures/models.py
index 51dad44..5b53115 100644
--- a/tests/modeltests/fixtures/models.py
+++ b/tests/modeltests/fixtures/models.py
@@ -20,16 +20,6 @@ class Article(models.Model):
 
     class Meta:
         ordering = ('-pub_date', 'headline')
-        
-class Category(models.Model):
-    title = models.CharField(max_length=100)
-    description = models.TextField()
-    
-    def __unicode__(self):
-        return self.title
-
-    class Meta:
-        ordering = ('title',)
 
 __test__ = {'API_TESTS': """
 >>> from django.core import management
@@ -92,26 +82,6 @@ Multiple fixtures named 'fixture2' in '...fixtures'. Aborting.
 # Dump the current contents of the database as a JSON fixture
 >>> management.call_command('dumpdata', 'fixtures', format='json')
 [{"pk": 3, "model": "fixtures.article", "fields": {"headline": "Time to reform copyright", "pub_date": "2006-06-16 13:00:00"}}, {"pk": 2, "model": "fixtures.article", "fields": {"headline": "Poker has no place on ESPN", "pub_date": "2006-06-16 12:00:00"}}, {"pk": 1, "model": "fixtures.article", "fields": {"headline": "Python program becomes self aware", "pub_date": "2006-06-16 11:00:00"}}]
-
-# Reset Database representation again.
->>> management.call_command('flush', verbosity=0, interactive=False)
->>> management.call_command('loaddata', 'fixture4', verbosity=0)
->>> Article.objects.all()
-[<Article: Time to reform copyright>, <Article: Poker has no place on ESPN>, <Article: Python program becomes self aware>]
->>> Category.objects.all()
-[<Category: News Stories>]
-
-# Dump the contents of the database as a JSON fixture
->>> management.call_command('dumpdata', 'fixtures', format='json')
-[{"pk": 1, "model": "fixtures.category", "fields": {"description": "Latest news stories", "title": "News Stories"}}, {"pk": 3, "model": "fixtures.article", "fields": {"headline": "Time to reform copyright", "pub_date": "2006-06-16 13:00:00"}}, {"pk": 2, "model": "fixtures.article", "fields": {"headline": "Poker has no place on ESPN", "pub_date": "2006-06-16 12:00:00"}}, {"pk": 1, "model": "fixtures.article", "fields": {"headline": "Python program becomes self aware", "pub_date": "2006-06-16 11:00:00"}}]
-
-# Try just dumping the contents of fixtures.Category
->>> management.call_command('dumpdata', 'fixtures.Category', format='json')
-[{"pk": 1, "model": "fixtures.category", "fields": {"description": "Latest news stories", "title": "News Stories"}}]
-
-# ..and just fixtures.Article
->>> management.call_command('dumpdata', 'fixtures.Article', format='json')
-[{"pk": 3, "model": "fixtures.article", "fields": {"headline": "Time to reform copyright", "pub_date": "2006-06-16 13:00:00"}}, {"pk": 2, "model": "fixtures.article", "fields": {"headline": "Poker has no place on ESPN", "pub_date": "2006-06-16 12:00:00"}}, {"pk": 1, "model": "fixtures.article", "fields": {"headline": "Python program becomes self aware", "pub_date": "2006-06-16 11:00:00"}}]
 """
 
 from django.test import TestCase