Index: django/contrib/auth/management.py
===================================================================
--- django/contrib/auth/management.py	(revision 7027)
+++ django/contrib/auth/management.py	(working copy)
@@ -1,49 +0,0 @@
-"""
-Creates permissions for all installed apps that need permissions.
-"""
-
-from django.dispatch import dispatcher
-from django.db.models import get_models, signals
-from django.contrib.auth import models as auth_app
-
-def _get_permission_codename(action, opts):
-    return u'%s_%s' % (action, opts.object_name.lower())
-
-def _get_all_permissions(opts):
-    "Returns (codename, name) for all permissions in the given opts."
-    perms = []
-    for action in ('add', 'change', 'delete'):
-        perms.append((_get_permission_codename(action, opts), u'Can %s %s' % (action, opts.verbose_name_raw)))
-    return perms + list(opts.permissions)
-
-def create_permissions(app, created_models, verbosity):
-    from django.contrib.contenttypes.models import ContentType
-    from django.contrib.auth.models import Permission
-    app_models = get_models(app)
-    if not app_models:
-        return
-    for klass in app_models:
-        ctype = ContentType.objects.get_for_model(klass)
-        for codename, name in _get_all_permissions(klass._meta):
-            p, created = Permission.objects.get_or_create(codename=codename, content_type__pk=ctype.id,
-                defaults={'name': name, 'content_type': ctype})
-            if created and verbosity >= 2:
-                print "Adding permission '%s'" % p
-
-def create_superuser(app, created_models, verbosity, **kwargs):
-    from django.contrib.auth.models import User
-    from django.contrib.auth.create_superuser import createsuperuser as do_create
-    if User in created_models and kwargs.get('interactive', True):
-        msg = "\nYou just installed Django's auth system, which means you don't have " \
-                "any superusers defined.\nWould you like to create one now? (yes/no): "
-        confirm = raw_input(msg)
-        while 1:
-            if confirm not in ('yes', 'no'):
-                confirm = raw_input('Please enter either "yes" or "no": ')
-                continue
-            if confirm == 'yes':
-                do_create()
-            break
-
-dispatcher.connect(create_permissions, signal=signals.post_syncdb)
-dispatcher.connect(create_superuser, sender=auth_app, signal=signals.post_syncdb)
Index: django/contrib/auth/create_superuser.py
===================================================================
--- django/contrib/auth/create_superuser.py	(revision 7027)
+++ django/contrib/auth/create_superuser.py	(working copy)
@@ -1,94 +1,9 @@
 """
-Helper function for creating superusers in the authentication system.
-
 If run from the command line, this module lets you create a superuser
 interactively.
 """
 
-from django.core import validators
-from django.contrib.auth.models import User
-import getpass
-import os
-import sys
-import re
+from django.contrib.auth.management.commands.createsuperuser import createsuperuser
 
-RE_VALID_USERNAME = re.compile('\w+$')
-
-def createsuperuser(username=None, email=None, password=None):
-    """
-    Helper function for creating a superuser from the command line. All
-    arguments are optional and will be prompted-for if invalid or not given.
-    """
-    try:
-        import pwd
-    except ImportError:
-        default_username = ''
-    else:
-        # Determine the current system user's username, to use as a default.
-        default_username = pwd.getpwuid(os.getuid())[0].replace(' ', '').lower()
-
-    # Determine whether the default username is taken, so we don't display
-    # it as an option.
-    if default_username:
-        try:
-            User.objects.get(username=default_username)
-        except User.DoesNotExist:
-            pass
-        else:
-            default_username = ''
-
-    try:
-        while 1:
-            if not username:
-                input_msg = 'Username'
-                if default_username:
-                    input_msg += ' (Leave blank to use %r)' % default_username
-                username = raw_input(input_msg + ': ')
-            if default_username and username == '':
-                username = default_username
-            if not RE_VALID_USERNAME.match(username):
-                sys.stderr.write("Error: That username is invalid. Use only letters, digits and underscores.\n")
-                username = None
-                continue
-            try:
-                User.objects.get(username=username)
-            except User.DoesNotExist:
-                break
-            else:
-                sys.stderr.write("Error: That username is already taken.\n")
-                username = None
-        while 1:
-            if not email:
-                email = raw_input('E-mail address: ')
-            try:
-                validators.isValidEmail(email, None)
-            except validators.ValidationError:
-                sys.stderr.write("Error: That e-mail address is invalid.\n")
-                email = None
-            else:
-                break
-        while 1:
-            if not password:
-                password = getpass.getpass()
-                password2 = getpass.getpass('Password (again): ')
-                if password != password2:
-                    sys.stderr.write("Error: Your passwords didn't match.\n")
-                    password = None
-                    continue
-            if password.strip() == '':
-                sys.stderr.write("Error: Blank passwords aren't allowed.\n")
-                password = None
-                continue
-            break
-    except KeyboardInterrupt:
-        sys.stderr.write("\nOperation cancelled.\n")
-        sys.exit(1)
-    u = User.objects.create_user(username, email, password)
-    u.is_staff = True
-    u.is_active = True
-    u.is_superuser = True
-    u.save()
-    print "Superuser created successfully."
-
 if __name__ == "__main__":
     createsuperuser()
Index: django/contrib/auth/models.py
===================================================================
--- django/contrib/auth/models.py	(revision 7027)
+++ django/contrib/auth/models.py	(working copy)
@@ -116,6 +116,13 @@
         user.save()
         return user
 
+    def create_superuser(self, username, email, password):
+        u = self.create_user(username, email, password)
+        u.is_staff = True
+        u.is_active = True
+        u.is_superuser = True
+        u.save()
+
     def make_random_password(self, length=10, allowed_chars='abcdefghjkmnpqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ23456789'):
         "Generates a random password with the given length and given allowed_chars"
         # Note that default value of allowed_chars does not have "I" or letters
Index: django/contrib/auth/management/commands/__init__.py
===================================================================
Index: django/contrib/auth/management/commands/createsuperuser.py
===================================================================
--- django/contrib/auth/management/commands/createsuperuser.py	(revision 0)
+++ django/contrib/auth/management/commands/createsuperuser.py	(revision 0)
@@ -0,0 +1,106 @@
+from django.core.management.base import BaseCommand
+from optparse import make_option
+
+"""
+Helper function for creating superusers in the authentication system.
+
+If this management command is run, this command lets you create a superuser
+interactively.
+"""
+
+from django.core import validators
+from django.contrib.auth.models import User
+import getpass
+import os
+import sys
+import re
+
+RE_VALID_USERNAME = re.compile('\w+$')
+
+def createsuperuser(username=None, email=None, password=None):
+    """
+    Helper function for creating a superuser from the command line. All
+    arguments are optional and will be prompted-for if invalid or not given.
+    """
+    try:
+        import pwd
+    except ImportError:
+        default_username = ''
+    else:
+        # Determine the current system user's username, to use as a default.
+        default_username = pwd.getpwuid(os.getuid())[0].replace(' ', '').lower()
+
+    # Determine whether the default username is taken, so we don't display
+    # it as an option.
+    if default_username:
+        try:
+            User.objects.get(username=default_username)
+        except User.DoesNotExist:
+            pass
+        else:
+            default_username = ''
+
+    try:
+        while 1:
+            if not username:
+                input_msg = 'Username'
+                if default_username:
+                    input_msg += ' (Leave blank to use %r)' % default_username
+                username = raw_input(input_msg + ': ')
+            if default_username and username == '':
+                username = default_username
+            if not RE_VALID_USERNAME.match(username):
+                sys.stderr.write("Error: That username is invalid. Use only letters, digits and underscores.\n")
+                username = None
+                continue
+            try:
+                User.objects.get(username=username)
+            except User.DoesNotExist:
+                break
+            else:
+                sys.stderr.write("Error: That username is already taken.\n")
+                username = None
+        while 1:
+            if not email:
+                email = raw_input('E-mail address: ')
+            try:
+                validators.isValidEmail(email, None)
+            except validators.ValidationError:
+                sys.stderr.write("Error: That e-mail address is invalid.\n")
+                email = None
+            else:
+                break
+        while 1:
+            if not password:
+                password = getpass.getpass()
+                password2 = getpass.getpass('Password (again): ')
+                if password != password2:
+                    sys.stderr.write("Error: Your passwords didn't match.\n")
+                    password = None
+                    continue
+            if password.strip() == '':
+                sys.stderr.write("Error: Blank passwords aren't allowed.\n")
+                password = None
+                continue
+            break
+    except KeyboardInterrupt:
+        sys.stderr.write("\nOperation cancelled.\n")
+        sys.exit(1)
+    User.objects.create_superuser(username, email, password)
+    print "Superuser created successfully."
+
+class Command(BaseCommand):
+    option_list = BaseCommand.option_list + (
+        make_option('--username', dest='username', default=None,
+            help='Specifies the username for the superuser.'),
+        make_option('--email', dest='email', default=None,
+            help='Specifies the email address for the superuser.'),
+    )
+    help = 'Used to create a superuser.'
+
+    def handle(self, *args, **options):
+        username = options.get('username', None)
+        email = options.get('email', None)
+
+        createsuperuser(username=username, password=None, email=email)
+
Index: django/contrib/auth/management/__init__.py
===================================================================
--- django/contrib/auth/management/__init__.py	(revision 0)
+++ django/contrib/auth/management/__init__.py	(revision 0)
@@ -0,0 +1,51 @@
+"""
+Creates permissions for all installed apps that need permissions.
+"""
+
+from django.dispatch import dispatcher
+from django.db.models import get_models, signals
+from django.contrib.auth import models as auth_app
+
+def _get_permission_codename(action, opts):
+    return u'%s_%s' % (action, opts.object_name.lower())
+
+def _get_all_permissions(opts):
+    "Returns (codename, name) for all permissions in the given opts."
+    perms = []
+    for action in ('add', 'change', 'delete'):
+        perms.append((_get_permission_codename(action, opts), u'Can %s %s' % (action, opts.verbose_name_raw)))
+    return perms + list(opts.permissions)
+
+def create_permissions(app, created_models, verbosity):
+    from django.contrib.contenttypes.models import ContentType
+    from django.contrib.auth.models import Permission
+    app_models = get_models(app)
+    if not app_models:
+        return
+    for klass in app_models:
+        ctype = ContentType.objects.get_for_model(klass)
+        for codename, name in _get_all_permissions(klass._meta):
+            p, created = Permission.objects.get_or_create(codename=codename, content_type__pk=ctype.id,
+                defaults={'name': name, 'content_type': ctype})
+            if created and verbosity >= 2:
+                print "Adding permission '%s'" % p
+
+def create_superuser(app, created_models, verbosity, **kwargs):
+    from django.contrib.auth.models import User
+    from django.contrib.auth.management.commands.createsuperuser import createsuperuser as do_create
+    if User in created_models and kwargs.get('interactive', True):
+        msg = "\nYou just installed Django's auth system, which means you don't have " \
+                "any superusers defined.\nWould you like to create one now? (yes/no): "
+        confirm = raw_input(msg)
+        while 1:
+            if confirm not in ('yes', 'no'):
+                confirm = raw_input('Please enter either "yes" or "no": ')
+                continue
+            if confirm == 'yes':
+                do_create()
+            break
+
+if 'create_permissions' not in [i.__name__ for i in dispatcher.getAllReceivers(signal=signals.post_syncdb)]:
+    dispatcher.connect(create_permissions, signal=signals.post_syncdb)
+if 'create_superuser' not in [i.__name__ for i in dispatcher.getAllReceivers(signal=signals.post_syncdb, sender=auth_app)]:
+    dispatcher.connect(create_superuser, sender=auth_app, signal=signals.post_syncdb)